Bio::Tools::HMMER::Results(3)

NAME
Bio::Tools::HMMER::Results - Object representing HMMER output results

SYNOPSIS
   # parse a hmmsearch file (can also parse a hmmpfam file)
   $res = Bio::Tools::HMMER::Results->new( -file => 'output.hmm' ,
                                          -type => 'hmmsearch');

   # print out the results for each sequence
   foreach $seq ( $res->each_Set ) {
       print "Sequence bit score is",$seq->bits,"\n";
       foreach $domain ( $seq->each_Domain ) {
           print " Domain start ",$domain->start," end ",$domain->end,
           " score ",$domain->bits,"\n";
       }
   }

   # new result object on a sequence/domain cutoff of
   # 25 bits sequence, 15 bits domain
   $newresult = $res->filter_on_cutoff(25,15);

   # alternative way of getting out all domains directly
   foreach $domain ( $res->each_Domain ) {
       print "Domain on ",$domain->seq_id," with score ",
       $domain->bits," evalue ",$domain->evalue,"\n";
   }

DESCRIPTION
This object represents HMMER output, either from hmmsearch or hmmpfam. For hmmsearch, a series of HMMER::Set objects are made, one for each sequence, which have the the bits score for the object. For hmmpfam searches, only one Set object is made.

These objects come from the original HMMResults modules used internally in Pfam, written by Ewan Birney. Ewan then converted them to BioPerl objects in 1999. That conversion is meant to be backwardly compatible, but may not be (caveat emptor).

FEEDBACK

  Mailing Lists
User feedback is an integral part of the evolution of this and other Bioperl modules. Send your comments and suggestions preferably to one of the Bioperl mailing lists. Your participation is much appreciated.

  bioperl-l@bioperl.org                  - General discussion
  http://bioperl.org/wiki/Mailing_lists  - About the mailing lists

  Support
Please direct usage questions or support issues to the mailing list:

bioperl-l@bioperl.org

rather than to the module maintainer directly. Many experienced and reponsive experts will be able look at the problem and quickly address it. Please include a thorough description of the problem with code and data examples if at all possible.

  Reporting Bugs
Report bugs to the Bioperl bug tracking system to help us keep track the bugs and their resolution. Bug reports can be submitted via the web:

  http://bugzilla.open-bio.org/

AUTHOR - Ewan Birney
Email birney@ebi.ac.uk

CONTRIBUTORS
Jason Stajich, jason-at-bioperl.org

APPENDIX
The rest of the documentation details each of the object methods. Internal methods are usually preceded with a _

  next_feature
 Title   : next_feature
 Usage   : while( my $feat = $res->next_feature ) { # do something }
 Function: SeqAnalysisParserI implementing function
 Example :
 Returns : A Bio::SeqFeatureI compliant object, in this case,
           each DomainUnit object, ie, flattening the Sequence
           aspect of this.
 Args    : None

  number
 Title   : number
 Usage   : print "There are ",$res->number," domains hit\n";
 Function: provides the number of domains in the HMMER report

  seqfile
 Title   : seqfile
 Usage   : $obj->seqfile($newval)
 Function:
 Example :
 Returns : value of seqfile
 Args    : newvalue (optional)

  hmmfile
 Title   : hmmfile
 Usage   : $obj->hmmfile($newval)
 Function:
 Example :
 Returns : value of hmmfile
 Args    : newvalue (optional)

  add_Domain
 Title   : add_Domain
 Usage   : $res->add_Domain($unit)
 Function: adds a domain to the results array. Mainly used internally.
 Args    : A Bio::Tools::HMMER::Domain

  each_Domain
 Title   : each_Domain
 Usage   : foreach $domain ( $res->each_Domain() )
 Function: array of Domain units which are held in this report
 Returns : array
 Args    : none

  domain_bits_cutoff_from_evalue
 Title   : domain_bits_cutoff_from_evalue
 Usage   : $cutoff = domain_bits_cutoff_from_evalue(0.01);
 Function: return a bits cutoff from an evalue using the
           scores here. Somewhat interesting logic:
            Find the two bit score which straddle the evalue
            if( 25 is between these two points) return 25
            else return the midpoint.

           This logic tries to ensure that with large signal to
           noise separation one still has sensible 25 bit cutoff
 Returns :
 Args    :

  write_FT_output
 Title   : write_FT_output
 Usage   : $res->write_FT_output(\*STDOUT,'DOMAIN')
 Function: writes feature table output ala swissprot
 Returns :
 Args    :

  filter_on_cutoff
 Title   : filter_on_cutoff
 Usage   : $newresults = $results->filter_on_cutoff(25,15);
 Function: Produces a new HMMER::Results module which has
           been trimmed at the cutoff.
 Returns : a Bio::Tools::HMMER::Results module
 Args    : sequence cutoff and domain cutoff. in bits score
           if you want one cutoff, simply use same number both places

  write_ascii_out
 Title   : write_ascii_out
 Usage   : $res->write_ascii_out(\*STDOUT)
 Function: writes as
           seq seq_start seq_end model-acc model_start model_end model_name
 Returns :
 Args    :

  FIXME: Now that we have no modelacc, this is probably a bad thing.

  write_GDF_bits
 Title   : write_GDF_bits
 Usage   : $res->write_GDF_bits(25,15,\*STDOUT)
 Function: writes GDF format with a sequence,domain threshold
 Returns :
 Args    :

  add_Set
 Title   : add_Set
 Usage   : Mainly internal function
 Function:
 Returns :
 Args    :

  each_Set
 Title   : each_Set
 Usage   :
 Function:
 Returns :
 Args    :

  get_Set
 Title   : get_Set
 Usage   : $set = $res->get_Set('sequence-name');
 Function: returns the Set for a particular sequence
 Returns : a HMMER::Set object
 Args    : name of the sequence

  _parse_hmmpfam
 Title   : _parse_hmmpfam
 Usage   : $res->_parse_hmmpfam($filehandle)
 Function:
 Returns :
 Args    :

  _parse_hmmsearch
 Title   : _parse_hmmsearch
 Usage   : $res->_parse_hmmsearch($filehandle)
 Function:
 Returns :
 Args    :

  parsetype
 Title   : parsetype
 Usage   : $obj->parsetype($newval)
 Function:
 Returns : value of parsetype
 Args    : newvalue (optional)